#include <cmath>
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

#include "../Triangulation/pt.h"
#include "../Triangulation/Triangle.h"
#include "../Triangulation/FoncteursUtilitaires.h"
#include "../Triangulation/Polygone.h"

int main ()
{
/*
   pt p0 (0.0f, 2.0f, 0.0f),
      p1 (1.0f, 0.0f, 0.0f),
      p2 (1.5f, 2.0f, 0.0f),
      p3 (3.0f, 0.0f, 0.0f);
   if (VirageHoraire (p0, p1, p2))
      std::cout << "Virage horaire de " << p0 << "," << p1 << "  " << p1 << "," << p2 << std::endl;
   else
      std::cout << "Virage antihoraire de " << p0 << "," << p1 << "  " << p1 << "," << p2 << std::endl;
   if (VirageHoraire (p1, p2, p3))
      std::cout << "Virage horaire de " << p1 << "," << p2 << "  " << p2 << "," << p3 << std::endl;
   else
      std::cout << "Virage antihoraire de " << p1 << "," << p2 << "  " << p2 << "," << p3 << std::endl;
*/
   std::vector<pt> v;

   v.push_back (pt (0.0f, 2.0f, 0.0f));
   v.push_back (pt (1.0f, 0.0f, 0.0f));
   v.push_back (pt (1.5f, 2.0f, 0.0f));
   v.push_back (pt (3.0f, 0.0f, 0.0f));
   v.push_back (pt (2.0f, 4.0f, 0.0f));
   v.push_back (pt (0.5f, 1.5f, 0.0f));

   Polygone p (v);

   std::cout << p.CompterPrimitives () << " primitives" << std::endl;
   std::vector<Triangle*> vt = p.EnumererPrimitives ();
   std::for_each (vt.begin (), vt.end (), AfficherPtr <Triangle*>(std::cout, "Triangle: ", "\n"));
   std::for_each (vt.begin (), vt.end (), Detruire<Triangle*>);
}
